/* xkblayout.c generated by valac 0.56.18, the Vala compiler
 * generated from xkblayout.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2014 Red Hat, Inc.
 * Copyright(c) 2014 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2014-2025 Takao Fujiwara <tfujiwar@redhat.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>
#include <ibus.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#define XKB_LAYOUT_XKB_COMMAND "setxkbmap"
#define XKB_LAYOUT_XKB_LAYOUT_ARG "-layout"
#define XKB_LAYOUT_XMODMAP_COMMAND "xmodmap"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_XKB_LAYOUT (xkb_layout_get_type ())
#define XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_XKB_LAYOUT, XKBLayout))
#define XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_XKB_LAYOUT, XKBLayoutClass))
#define IS_XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_XKB_LAYOUT))
#define IS_XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_XKB_LAYOUT))
#define XKB_LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_XKB_LAYOUT, XKBLayoutClass))

typedef struct _XKBLayout XKBLayout;
typedef struct _XKBLayoutClass XKBLayoutClass;
typedef struct _XKBLayoutPrivate XKBLayoutPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecXKBLayout ParamSpecXKBLayout;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _XKBLayout {
	GTypeInstance parent_instance;
	volatile int ref_count;
	XKBLayoutPrivate * priv;
};

struct _XKBLayoutClass {
	GTypeClass parent_class;
	void (*finalize) (XKBLayout *self);
};

struct _XKBLayoutPrivate {
	gchar** m_get_layout_args;
	gint m_get_layout_args_length1;
	gint _m_get_layout_args_size_;
	gchar** m_xkb_latin_layouts;
	gint m_xkb_latin_layouts_length1;
	gint _m_xkb_latin_layouts_size_;
	gchar* m_default_layout;
	gchar* m_default_variant;
	gchar* m_default_option;
	gboolean m_use_xmodmap;
};

struct _ParamSpecXKBLayout {
	GParamSpec parent_instance;
};

static gint XKBLayout_private_offset;
static gpointer xkb_layout_parent_class = NULL;

VALA_EXTERN gpointer xkb_layout_ref (gpointer instance);
VALA_EXTERN void xkb_layout_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_xkb_layout (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_xkb_layout (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_xkb_layout (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_xkb_layout (const GValue* value);
VALA_EXTERN GType xkb_layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (XKBLayout, xkb_layout_unref)
VALA_EXTERN XKBLayout* xkb_layout_new (void);
VALA_EXTERN XKBLayout* xkb_layout_construct (GType object_type);
VALA_EXTERN void xkb_layout_set_latin_layouts (XKBLayout* self,
                                   gchar** xkb_latin_layouts,
                                   gint xkb_latin_layouts_length1);
static gchar** _vala_array_dup6 (gchar** self,
                          gssize length);
VALA_EXTERN void xkb_layout_get_layout (XKBLayout* self,
                            gchar** layout,
                            gchar** variant,
                            gchar** option);
static void xkb_layout_search_get_layout_program (XKBLayout* self);
static void _vala_array_add32 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void xkb_layout_parse_localectl_status_str (XKBLayout* self,
                                            const gchar* standard_output,
                                            gchar** layout,
                                            gchar** variant,
                                            gchar** option);
static void xkb_layout_parse_xkbmap_query_str (XKBLayout* self,
                                        const gchar* standard_output,
                                        gchar** layout,
                                        gchar** variant,
                                        gchar** option);
VALA_EXTERN gboolean binding_common_default_is_xdisplay (void);
VALA_EXTERN void xkb_layout_set_layout (XKBLayout* self,
                            IBusEngineDesc* engine);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_add33 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add34 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add35 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add36 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add37 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add38 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add39 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add40 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void xkb_layout_run_xmodmap (XKBLayout* self);
VALA_EXTERN void xkb_layout_set_use_xmodmap (XKBLayout* self,
                                 gboolean use_xmodmap);
static void xkb_layout_finalize (XKBLayout * obj);
static GType xkb_layout_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const gchar* XKB_LAYOUT_XMODMAP_KNOWN_FILES[4] = {".xmodmap", ".xmodmaprc", ".Xmodmap", ".Xmodmaprc"};

static inline gpointer
xkb_layout_get_instance_private (XKBLayout* self)
{
	return G_STRUCT_MEMBER_P (self, XKBLayout_private_offset);
}

XKBLayout*
xkb_layout_construct (GType object_type)
{
	XKBLayout* self = NULL;
#line 39 "xkblayout.vala"
	self = (XKBLayout*) g_type_create_instance (object_type);
#line 39 "xkblayout.vala"
	return self;
#line 215 "xkblayout.c"
}

XKBLayout*
xkb_layout_new (void)
{
#line 39 "xkblayout.vala"
	return xkb_layout_construct (TYPE_XKB_LAYOUT);
#line 223 "xkblayout.c"
}

static gchar**
_vala_array_dup6 (gchar** self,
                  gssize length)
{
#line 44 "xkblayout.vala"
	if (length >= 0) {
#line 232 "xkblayout.c"
		gchar** result;
		gssize i;
#line 44 "xkblayout.vala"
		result = g_new0 (gchar*, length + 1);
#line 44 "xkblayout.vala"
		for (i = 0; i < length; i++) {
#line 239 "xkblayout.c"
			gchar* _tmp0_;
#line 44 "xkblayout.vala"
			_tmp0_ = g_strdup (self[i]);
#line 44 "xkblayout.vala"
			result[i] = _tmp0_;
#line 245 "xkblayout.c"
		}
#line 44 "xkblayout.vala"
		return result;
#line 249 "xkblayout.c"
	}
#line 44 "xkblayout.vala"
	return NULL;
#line 253 "xkblayout.c"
}

void
xkb_layout_set_latin_layouts (XKBLayout* self,
                              gchar** xkb_latin_layouts,
                              gint xkb_latin_layouts_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 43 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 44 "xkblayout.vala"
	_tmp0_ = (xkb_latin_layouts != NULL) ? _vala_array_dup6 (xkb_latin_layouts, xkb_latin_layouts_length1) : xkb_latin_layouts;
#line 44 "xkblayout.vala"
	_tmp0__length1 = xkb_latin_layouts_length1;
#line 44 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts = (_vala_array_free (self->priv->m_xkb_latin_layouts, self->priv->m_xkb_latin_layouts_length1, (GDestroyNotify) g_free), NULL);
#line 44 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts = _tmp0_;
#line 44 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts_length1 = _tmp0__length1;
#line 44 "xkblayout.vala"
	self->priv->_m_xkb_latin_layouts_size_ = self->priv->m_xkb_latin_layouts_length1;
#line 277 "xkblayout.c"
}

static void
_vala_array_add32 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 63 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 63 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 63 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 292 "xkblayout.c"
	}
#line 63 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 63 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 298 "xkblayout.c"
}

void
xkb_layout_get_layout (XKBLayout* self,
                       gchar** layout,
                       gchar** variant,
                       gchar** option)
{
	gchar* _vala_layout = NULL;
	gchar* _vala_variant = NULL;
	gchar* _vala_option = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* o = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar** exec_command = NULL;
	gchar** _tmp10_;
	gint exec_command_length1;
	gint _exec_command_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* standard_output = NULL;
	gchar* standard_error = NULL;
	gint exit_status = 0;
	const gchar* _tmp24_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	const gchar* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 48 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 51 "xkblayout.vala"
	_tmp0_ = g_strdup ("");
#line 51 "xkblayout.vala"
	_g_free0 (_vala_layout);
#line 51 "xkblayout.vala"
	_vala_layout = _tmp0_;
#line 52 "xkblayout.vala"
	_tmp1_ = g_strdup ("");
#line 52 "xkblayout.vala"
	_g_free0 (_vala_variant);
#line 52 "xkblayout.vala"
	_vala_variant = _tmp1_;
#line 53 "xkblayout.vala"
	_tmp2_ = g_getenv ("XKB_DEFAULT_OPTIONS");
#line 53 "xkblayout.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 53 "xkblayout.vala"
	o = _tmp3_;
#line 54 "xkblayout.vala"
	_tmp5_ = o;
#line 54 "xkblayout.vala"
	if (_tmp5_ != NULL) {
#line 359 "xkblayout.c"
		const gchar* _tmp6_;
#line 54 "xkblayout.vala"
		_tmp6_ = o;
#line 54 "xkblayout.vala"
		_tmp4_ = _tmp6_;
#line 365 "xkblayout.c"
	} else {
#line 54 "xkblayout.vala"
		_tmp4_ = "";
#line 369 "xkblayout.c"
	}
#line 54 "xkblayout.vala"
	_tmp7_ = g_strdup (_tmp4_);
#line 54 "xkblayout.vala"
	_g_free0 (_vala_option);
#line 54 "xkblayout.vala"
	_vala_option = _tmp7_;
#line 56 "xkblayout.vala"
	xkb_layout_search_get_layout_program (self);
#line 57 "xkblayout.vala"
	_tmp8_ = self->priv->m_get_layout_args;
#line 57 "xkblayout.vala"
	_tmp8__length1 = self->priv->m_get_layout_args_length1;
#line 57 "xkblayout.vala"
	_tmp9_ = _tmp8_[0];
#line 57 "xkblayout.vala"
	if (_tmp9_ == NULL) {
#line 58 "xkblayout.vala"
		g_warning ("xkblayout.vala:58: Not found localectl or setxkbmap command in PATH");
#line 59 "xkblayout.vala"
		_g_free0 (o);
#line 59 "xkblayout.vala"
		if (layout) {
#line 59 "xkblayout.vala"
			*layout = _vala_layout;
#line 395 "xkblayout.c"
		} else {
#line 59 "xkblayout.vala"
			_g_free0 (_vala_layout);
#line 399 "xkblayout.c"
		}
#line 59 "xkblayout.vala"
		if (variant) {
#line 59 "xkblayout.vala"
			*variant = _vala_variant;
#line 405 "xkblayout.c"
		} else {
#line 59 "xkblayout.vala"
			_g_free0 (_vala_variant);
#line 409 "xkblayout.c"
		}
#line 59 "xkblayout.vala"
		if (option) {
#line 59 "xkblayout.vala"
			*option = _vala_option;
#line 415 "xkblayout.c"
		} else {
#line 59 "xkblayout.vala"
			_g_free0 (_vala_option);
#line 419 "xkblayout.c"
		}
#line 59 "xkblayout.vala"
		return;
#line 423 "xkblayout.c"
	}
#line 61 "xkblayout.vala"
	_tmp10_ = g_new0 (gchar*, 0 + 1);
#line 61 "xkblayout.vala"
	exec_command = _tmp10_;
#line 61 "xkblayout.vala"
	exec_command_length1 = 0;
#line 61 "xkblayout.vala"
	_exec_command_size_ = exec_command_length1;
#line 62 "xkblayout.vala"
	_tmp11_ = self->priv->m_get_layout_args;
#line 62 "xkblayout.vala"
	_tmp11__length1 = self->priv->m_get_layout_args_length1;
#line 437 "xkblayout.c"
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 62 "xkblayout.vala"
		arg_collection = _tmp11_;
#line 62 "xkblayout.vala"
		arg_collection_length1 = _tmp11__length1;
#line 62 "xkblayout.vala"
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 449 "xkblayout.c"
			const gchar* arg = NULL;
#line 62 "xkblayout.vala"
			arg = arg_collection[arg_it];
#line 453 "xkblayout.c"
			{
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 63 "xkblayout.vala"
				_tmp12_ = arg;
#line 63 "xkblayout.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 63 "xkblayout.vala"
				_vala_array_add32 (&exec_command, &exec_command_length1, &_exec_command_size_, _tmp13_);
#line 463 "xkblayout.c"
			}
		}
	}
#line 64 "xkblayout.vala"
	standard_output = NULL;
#line 65 "xkblayout.vala"
	standard_error = NULL;
#line 66 "xkblayout.vala"
	exit_status = 0;
#line 473 "xkblayout.c"
	{
		gchar** _tmp14_;
		gint _tmp14__length1;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gint _tmp17_ = 0;
#line 69 "xkblayout.vala"
		_tmp14_ = exec_command;
#line 69 "xkblayout.vala"
		_tmp14__length1 = exec_command_length1;
#line 69 "xkblayout.vala"
		g_spawn_sync (NULL, _tmp14_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp15_, &_tmp16_, &_tmp17_, &_inner_error0_);
#line 69 "xkblayout.vala"
		_g_free0 (standard_output);
#line 69 "xkblayout.vala"
		standard_output = _tmp15_;
#line 69 "xkblayout.vala"
		_g_free0 (standard_error);
#line 69 "xkblayout.vala"
		standard_error = _tmp16_;
#line 69 "xkblayout.vala"
		exit_status = _tmp17_;
#line 69 "xkblayout.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "xkblayout.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 500 "xkblayout.c"
				goto __catch0_g_spawn_error;
			}
#line 69 "xkblayout.vala"
			_g_free0 (standard_error);
#line 69 "xkblayout.vala"
			_g_free0 (standard_output);
#line 69 "xkblayout.vala"
			exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
#line 69 "xkblayout.vala"
			_g_free0 (o);
#line 69 "xkblayout.vala"
			_g_free0 (_vala_layout);
#line 69 "xkblayout.vala"
			_g_free0 (_vala_variant);
#line 69 "xkblayout.vala"
			_g_free0 (_vala_option);
#line 69 "xkblayout.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "xkblayout.vala"
			g_clear_error (&_inner_error0_);
#line 69 "xkblayout.vala"
			return;
#line 523 "xkblayout.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* err = NULL;
		FILE* _tmp18_;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 68 "xkblayout.vala"
		err = _inner_error0_;
#line 68 "xkblayout.vala"
		_inner_error0_ = NULL;
#line 78 "xkblayout.vala"
		_tmp18_ = stderr;
#line 78 "xkblayout.vala"
		_tmp19_ = err;
#line 78 "xkblayout.vala"
		_tmp20_ = _tmp19_->message;
#line 78 "xkblayout.vala"
		fprintf (_tmp18_, "IBUS_ERROR: %s\n", _tmp20_);
#line 68 "xkblayout.vala"
		_g_error_free0 (err);
#line 547 "xkblayout.c"
	}
	__finally0:
#line 68 "xkblayout.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "xkblayout.vala"
		_g_free0 (standard_error);
#line 68 "xkblayout.vala"
		_g_free0 (standard_output);
#line 68 "xkblayout.vala"
		exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
#line 68 "xkblayout.vala"
		_g_free0 (o);
#line 68 "xkblayout.vala"
		_g_free0 (_vala_layout);
#line 68 "xkblayout.vala"
		_g_free0 (_vala_variant);
#line 68 "xkblayout.vala"
		_g_free0 (_vala_option);
#line 68 "xkblayout.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 68 "xkblayout.vala"
		g_clear_error (&_inner_error0_);
#line 68 "xkblayout.vala"
		return;
#line 572 "xkblayout.c"
	}
#line 80 "xkblayout.vala"
	if (exit_status != 0) {
#line 576 "xkblayout.c"
		const gchar* _tmp21_ = NULL;
		const gchar* _tmp22_;
		FILE* _tmp23_;
#line 81 "xkblayout.vala"
		_tmp22_ = standard_error;
#line 81 "xkblayout.vala"
		_tmp21_ = _tmp22_;
#line 81 "xkblayout.vala"
		if (_tmp21_ == NULL) {
#line 81 "xkblayout.vala"
			_tmp21_ = "";
#line 588 "xkblayout.c"
		}
#line 81 "xkblayout.vala"
		_tmp23_ = stderr;
#line 81 "xkblayout.vala"
		fprintf (_tmp23_, "IBUS_ERROR: %s\n", _tmp21_);
#line 594 "xkblayout.c"
	}
#line 82 "xkblayout.vala"
	_tmp24_ = standard_output;
#line 82 "xkblayout.vala"
	if (_tmp24_ == NULL) {
#line 83 "xkblayout.vala"
		_g_free0 (standard_error);
#line 83 "xkblayout.vala"
		_g_free0 (standard_output);
#line 83 "xkblayout.vala"
		exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
#line 83 "xkblayout.vala"
		_g_free0 (o);
#line 83 "xkblayout.vala"
		if (layout) {
#line 83 "xkblayout.vala"
			*layout = _vala_layout;
#line 612 "xkblayout.c"
		} else {
#line 83 "xkblayout.vala"
			_g_free0 (_vala_layout);
#line 616 "xkblayout.c"
		}
#line 83 "xkblayout.vala"
		if (variant) {
#line 83 "xkblayout.vala"
			*variant = _vala_variant;
#line 622 "xkblayout.c"
		} else {
#line 83 "xkblayout.vala"
			_g_free0 (_vala_variant);
#line 626 "xkblayout.c"
		}
#line 83 "xkblayout.vala"
		if (option) {
#line 83 "xkblayout.vala"
			*option = _vala_option;
#line 632 "xkblayout.c"
		} else {
#line 83 "xkblayout.vala"
			_g_free0 (_vala_option);
#line 636 "xkblayout.c"
		}
#line 83 "xkblayout.vala"
		return;
#line 640 "xkblayout.c"
	}
#line 85 "xkblayout.vala"
	_tmp25_ = exec_command;
#line 85 "xkblayout.vala"
	_tmp25__length1 = exec_command_length1;
#line 85 "xkblayout.vala"
	_tmp26_ = _tmp25_[0];
#line 85 "xkblayout.vala"
	if (g_strcmp0 (_tmp26_, "localectl") == 0) {
#line 650 "xkblayout.c"
		const gchar* _tmp27_;
#line 86 "xkblayout.vala"
		_tmp27_ = standard_output;
#line 86 "xkblayout.vala"
		xkb_layout_parse_localectl_status_str (self, _tmp27_, &_vala_layout, &_vala_variant, &_vala_option);
#line 656 "xkblayout.c"
	} else {
		gchar** _tmp28_;
		gint _tmp28__length1;
		const gchar* _tmp29_;
#line 90 "xkblayout.vala"
		_tmp28_ = exec_command;
#line 90 "xkblayout.vala"
		_tmp28__length1 = exec_command_length1;
#line 90 "xkblayout.vala"
		_tmp29_ = _tmp28_[0];
#line 90 "xkblayout.vala"
		if (g_strcmp0 (_tmp29_, XKB_LAYOUT_XKB_COMMAND) == 0) {
#line 669 "xkblayout.c"
			const gchar* _tmp30_;
#line 91 "xkblayout.vala"
			_tmp30_ = standard_output;
#line 91 "xkblayout.vala"
			xkb_layout_parse_xkbmap_query_str (self, _tmp30_, &_vala_layout, &_vala_variant, &_vala_option);
#line 675 "xkblayout.c"
		}
	}
#line 48 "xkblayout.vala"
	_g_free0 (standard_error);
#line 48 "xkblayout.vala"
	_g_free0 (standard_output);
#line 48 "xkblayout.vala"
	exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
#line 48 "xkblayout.vala"
	_g_free0 (o);
#line 48 "xkblayout.vala"
	if (layout) {
#line 48 "xkblayout.vala"
		*layout = _vala_layout;
#line 690 "xkblayout.c"
	} else {
#line 48 "xkblayout.vala"
		_g_free0 (_vala_layout);
#line 694 "xkblayout.c"
	}
#line 48 "xkblayout.vala"
	if (variant) {
#line 48 "xkblayout.vala"
		*variant = _vala_variant;
#line 700 "xkblayout.c"
	} else {
#line 48 "xkblayout.vala"
		_g_free0 (_vala_variant);
#line 704 "xkblayout.c"
	}
#line 48 "xkblayout.vala"
	if (option) {
#line 48 "xkblayout.vala"
		*option = _vala_option;
#line 710 "xkblayout.c"
	} else {
#line 48 "xkblayout.vala"
		_g_free0 (_vala_option);
#line 714 "xkblayout.c"
	}
}

static void
xkb_layout_search_get_layout_program (XKBLayout* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp1_;
	gchar* get_layout_command = NULL;
	const gchar* _tmp11_;
#line 99 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 100 "xkblayout.vala"
	_tmp0_ = self->priv->m_get_layout_args;
#line 100 "xkblayout.vala"
	_tmp0__length1 = self->priv->m_get_layout_args_length1;
#line 100 "xkblayout.vala"
	_tmp1_ = _tmp0_[0];
#line 100 "xkblayout.vala"
	if (_tmp1_ != NULL) {
#line 101 "xkblayout.vala"
		return;
#line 738 "xkblayout.c"
	}
#line 102 "xkblayout.vala"
	get_layout_command = NULL;
#line 104 "xkblayout.vala"
	if (binding_common_default_is_xdisplay ()) {
#line 744 "xkblayout.c"
		gchar* _tmp2_;
#line 105 "xkblayout.vala"
		_tmp2_ = g_strdup ("setxkbmap -query");
#line 105 "xkblayout.vala"
		_g_free0 (get_layout_command);
#line 105 "xkblayout.vala"
		get_layout_command = _tmp2_;
#line 752 "xkblayout.c"
	} else {
		gchar* _tmp3_;
		gchar* _tmp4_;
		gboolean _tmp5_;
#line 106 "xkblayout.vala"
		_tmp3_ = g_find_program_in_path ("localectl");
#line 106 "xkblayout.vala"
		_tmp4_ = _tmp3_;
#line 106 "xkblayout.vala"
		_tmp5_ = _tmp4_ != NULL;
#line 106 "xkblayout.vala"
		_g_free0 (_tmp4_);
#line 106 "xkblayout.vala"
		if (_tmp5_) {
#line 767 "xkblayout.c"
			gchar* _tmp6_;
#line 107 "xkblayout.vala"
			_tmp6_ = g_strdup ("localectl status");
#line 107 "xkblayout.vala"
			_g_free0 (get_layout_command);
#line 107 "xkblayout.vala"
			get_layout_command = _tmp6_;
#line 775 "xkblayout.c"
		} else {
			gchar* _tmp7_;
			gchar* _tmp8_;
			gboolean _tmp9_;
#line 108 "xkblayout.vala"
			_tmp7_ = g_find_program_in_path ("setxkbmap");
#line 108 "xkblayout.vala"
			_tmp8_ = _tmp7_;
#line 108 "xkblayout.vala"
			_tmp9_ = _tmp8_ != NULL;
#line 108 "xkblayout.vala"
			_g_free0 (_tmp8_);
#line 108 "xkblayout.vala"
			if (_tmp9_) {
#line 790 "xkblayout.c"
				gchar* _tmp10_;
#line 109 "xkblayout.vala"
				_tmp10_ = g_strdup ("setxkbmap -query");
#line 109 "xkblayout.vala"
				_g_free0 (get_layout_command);
#line 109 "xkblayout.vala"
				get_layout_command = _tmp10_;
#line 798 "xkblayout.c"
			}
		}
	}
#line 110 "xkblayout.vala"
	_tmp11_ = get_layout_command;
#line 110 "xkblayout.vala"
	if (_tmp11_ != NULL) {
#line 806 "xkblayout.c"
		const gchar* _tmp12_;
		gchar** _tmp13_;
		gchar** _tmp14_;
#line 111 "xkblayout.vala"
		_tmp12_ = get_layout_command;
#line 111 "xkblayout.vala"
		_tmp14_ = _tmp13_ = g_strsplit (_tmp12_, " ", 0);
#line 111 "xkblayout.vala"
		self->priv->m_get_layout_args = (_vala_array_free (self->priv->m_get_layout_args, self->priv->m_get_layout_args_length1, (GDestroyNotify) g_free), NULL);
#line 111 "xkblayout.vala"
		self->priv->m_get_layout_args = _tmp14_;
#line 111 "xkblayout.vala"
		self->priv->m_get_layout_args_length1 = _vala_array_length (_tmp13_);
#line 111 "xkblayout.vala"
		self->priv->_m_get_layout_args_size_ = self->priv->m_get_layout_args_length1;
#line 822 "xkblayout.c"
	}
#line 99 "xkblayout.vala"
	_g_free0 (get_layout_command);
#line 826 "xkblayout.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 850 "xkblayout.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 858 "xkblayout.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 864 "xkblayout.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 892 "xkblayout.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 898 "xkblayout.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 904 "xkblayout.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 908 "xkblayout.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 916 "xkblayout.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 920 "xkblayout.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 932 "xkblayout.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 953 "xkblayout.c"
}

static void
xkb_layout_parse_localectl_status_str (XKBLayout* self,
                                       const gchar* standard_output,
                                       gchar** layout,
                                       gchar** variant,
                                       gchar** option)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
#line 115 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 115 "xkblayout.vala"
	g_return_if_fail (standard_output != NULL);
#line 115 "xkblayout.vala"
	g_return_if_fail (*layout != NULL);
#line 115 "xkblayout.vala"
	g_return_if_fail (*variant != NULL);
#line 115 "xkblayout.vala"
	g_return_if_fail (*option != NULL);
#line 119 "xkblayout.vala"
	_tmp1_ = _tmp0_ = g_strsplit (standard_output, "\n", 0);
#line 977 "xkblayout.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 119 "xkblayout.vala"
		line_collection = _tmp1_;
#line 119 "xkblayout.vala"
		line_collection_length1 = _vala_array_length (_tmp0_);
#line 119 "xkblayout.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 989 "xkblayout.c"
			gchar* _tmp2_;
			gchar* line = NULL;
#line 119 "xkblayout.vala"
			_tmp2_ = g_strdup (line_collection[line_it]);
#line 119 "xkblayout.vala"
			line = _tmp2_;
#line 996 "xkblayout.c"
			{
#line 120 "xkblayout.vala"
				static const gchar* elements[2] = {"X11 Layout:", "X11 Variant:"};
#line 1000 "xkblayout.c"
				{
					const gchar** element_collection = NULL;
					gint element_collection_length1 = 0;
					gint _element_collection_size_ = 0;
					gint element_it = 0;
#line 121 "xkblayout.vala"
					element_collection = elements;
#line 121 "xkblayout.vala"
					element_collection_length1 = G_N_ELEMENTS (elements);
#line 121 "xkblayout.vala"
					for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
#line 1012 "xkblayout.c"
						const gchar* element = NULL;
#line 121 "xkblayout.vala"
						element = element_collection[element_it];
#line 1016 "xkblayout.c"
						{
							gchar* retval = NULL;
							gchar* _tmp3_;
							gint index = 0;
							const gchar* _tmp4_;
							const gchar* _tmp5_;
#line 122 "xkblayout.vala"
							_tmp3_ = g_strdup ("");
#line 122 "xkblayout.vala"
							retval = _tmp3_;
#line 123 "xkblayout.vala"
							_tmp4_ = line;
#line 123 "xkblayout.vala"
							_tmp5_ = element;
#line 123 "xkblayout.vala"
							index = string_index_of (_tmp4_, _tmp5_, 0);
#line 124 "xkblayout.vala"
							if (index >= 0) {
#line 1035 "xkblayout.c"
								const gchar* _tmp6_;
								const gchar* _tmp7_;
								gint _tmp8_;
								gint _tmp9_;
								const gchar* _tmp10_;
								gint _tmp11_;
								gint _tmp12_;
								gchar* _tmp13_;
								const gchar* _tmp14_;
								const gchar* _tmp17_;
								const gchar* _tmp18_;
#line 125 "xkblayout.vala"
								_tmp6_ = line;
#line 125 "xkblayout.vala"
								_tmp7_ = element;
#line 125 "xkblayout.vala"
								_tmp8_ = strlen (_tmp7_);
#line 125 "xkblayout.vala"
								_tmp9_ = _tmp8_;
#line 125 "xkblayout.vala"
								_tmp10_ = line;
#line 125 "xkblayout.vala"
								_tmp11_ = strlen (_tmp10_);
#line 125 "xkblayout.vala"
								_tmp12_ = _tmp11_;
#line 125 "xkblayout.vala"
								_tmp13_ = string_slice (_tmp6_, (glong) (index + _tmp9_), (glong) _tmp12_);
#line 125 "xkblayout.vala"
								_g_free0 (retval);
#line 125 "xkblayout.vala"
								retval = _tmp13_;
#line 126 "xkblayout.vala"
								_tmp14_ = retval;
#line 126 "xkblayout.vala"
								if (_tmp14_ != NULL) {
#line 1071 "xkblayout.c"
									const gchar* _tmp15_;
									gchar* _tmp16_;
#line 127 "xkblayout.vala"
									_tmp15_ = retval;
#line 127 "xkblayout.vala"
									_tmp16_ = string_strip (_tmp15_);
#line 127 "xkblayout.vala"
									_g_free0 (retval);
#line 127 "xkblayout.vala"
									retval = _tmp16_;
#line 1082 "xkblayout.c"
								}
#line 128 "xkblayout.vala"
								_tmp17_ = element;
#line 128 "xkblayout.vala"
								_tmp18_ = elements[0];
#line 128 "xkblayout.vala"
								if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 1090 "xkblayout.c"
									const gchar* _tmp19_;
									gchar* _tmp20_;
#line 129 "xkblayout.vala"
									_tmp19_ = retval;
#line 129 "xkblayout.vala"
									_tmp20_ = g_strdup (_tmp19_);
#line 129 "xkblayout.vala"
									_g_free0 (*layout);
#line 129 "xkblayout.vala"
									*layout = _tmp20_;
#line 1101 "xkblayout.c"
								} else {
									const gchar* _tmp21_;
									const gchar* _tmp22_;
#line 130 "xkblayout.vala"
									_tmp21_ = element;
#line 130 "xkblayout.vala"
									_tmp22_ = elements[1];
#line 130 "xkblayout.vala"
									if (g_strcmp0 (_tmp21_, _tmp22_) == 0) {
#line 1111 "xkblayout.c"
										const gchar* _tmp23_;
										gchar* _tmp24_;
#line 131 "xkblayout.vala"
										_tmp23_ = retval;
#line 131 "xkblayout.vala"
										_tmp24_ = g_strdup (_tmp23_);
#line 131 "xkblayout.vala"
										_g_free0 (*variant);
#line 131 "xkblayout.vala"
										*variant = _tmp24_;
#line 1122 "xkblayout.c"
									}
								}
							}
#line 121 "xkblayout.vala"
							_g_free0 (retval);
#line 1128 "xkblayout.c"
						}
					}
				}
#line 119 "xkblayout.vala"
				_g_free0 (line);
#line 1134 "xkblayout.c"
			}
		}
#line 119 "xkblayout.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1139 "xkblayout.c"
	}
}

static void
xkb_layout_parse_xkbmap_query_str (XKBLayout* self,
                                   const gchar* standard_output,
                                   gchar** layout,
                                   gchar** variant,
                                   gchar** option)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
#line 138 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 138 "xkblayout.vala"
	g_return_if_fail (standard_output != NULL);
#line 138 "xkblayout.vala"
	g_return_if_fail (*layout != NULL);
#line 138 "xkblayout.vala"
	g_return_if_fail (*variant != NULL);
#line 138 "xkblayout.vala"
	g_return_if_fail (*option != NULL);
#line 142 "xkblayout.vala"
	_tmp1_ = _tmp0_ = g_strsplit (standard_output, "\n", 0);
#line 1164 "xkblayout.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 142 "xkblayout.vala"
		line_collection = _tmp1_;
#line 142 "xkblayout.vala"
		line_collection_length1 = _vala_array_length (_tmp0_);
#line 142 "xkblayout.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1176 "xkblayout.c"
			gchar* _tmp2_;
			gchar* line = NULL;
#line 142 "xkblayout.vala"
			_tmp2_ = g_strdup (line_collection[line_it]);
#line 142 "xkblayout.vala"
			line = _tmp2_;
#line 1183 "xkblayout.c"
			{
#line 143 "xkblayout.vala"
				static const gchar* elements[3] = {"layout:", "variant:", "options:"};
#line 1187 "xkblayout.c"
				{
					const gchar** element_collection = NULL;
					gint element_collection_length1 = 0;
					gint _element_collection_size_ = 0;
					gint element_it = 0;
#line 144 "xkblayout.vala"
					element_collection = elements;
#line 144 "xkblayout.vala"
					element_collection_length1 = G_N_ELEMENTS (elements);
#line 144 "xkblayout.vala"
					for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
#line 1199 "xkblayout.c"
						const gchar* element = NULL;
#line 144 "xkblayout.vala"
						element = element_collection[element_it];
#line 1203 "xkblayout.c"
						{
							gchar* retval = NULL;
							gchar* _tmp3_;
							const gchar* _tmp4_;
							const gchar* _tmp5_;
#line 145 "xkblayout.vala"
							_tmp3_ = g_strdup ("");
#line 145 "xkblayout.vala"
							retval = _tmp3_;
#line 146 "xkblayout.vala"
							_tmp4_ = line;
#line 146 "xkblayout.vala"
							_tmp5_ = element;
#line 146 "xkblayout.vala"
							if (g_str_has_prefix (_tmp4_, _tmp5_)) {
#line 1219 "xkblayout.c"
								const gchar* _tmp6_;
								const gchar* _tmp7_;
								gint _tmp8_;
								gint _tmp9_;
								const gchar* _tmp10_;
								gint _tmp11_;
								gint _tmp12_;
								gchar* _tmp13_;
								const gchar* _tmp14_;
								const gchar* _tmp17_;
								const gchar* _tmp18_;
#line 147 "xkblayout.vala"
								_tmp6_ = line;
#line 147 "xkblayout.vala"
								_tmp7_ = element;
#line 147 "xkblayout.vala"
								_tmp8_ = strlen (_tmp7_);
#line 147 "xkblayout.vala"
								_tmp9_ = _tmp8_;
#line 147 "xkblayout.vala"
								_tmp10_ = line;
#line 147 "xkblayout.vala"
								_tmp11_ = strlen (_tmp10_);
#line 147 "xkblayout.vala"
								_tmp12_ = _tmp11_;
#line 147 "xkblayout.vala"
								_tmp13_ = string_slice (_tmp6_, (glong) _tmp9_, (glong) _tmp12_);
#line 147 "xkblayout.vala"
								_g_free0 (retval);
#line 147 "xkblayout.vala"
								retval = _tmp13_;
#line 148 "xkblayout.vala"
								_tmp14_ = retval;
#line 148 "xkblayout.vala"
								if (_tmp14_ != NULL) {
#line 1255 "xkblayout.c"
									const gchar* _tmp15_;
									gchar* _tmp16_;
#line 149 "xkblayout.vala"
									_tmp15_ = retval;
#line 149 "xkblayout.vala"
									_tmp16_ = string_strip (_tmp15_);
#line 149 "xkblayout.vala"
									_g_free0 (retval);
#line 149 "xkblayout.vala"
									retval = _tmp16_;
#line 1266 "xkblayout.c"
								}
#line 150 "xkblayout.vala"
								_tmp17_ = element;
#line 150 "xkblayout.vala"
								_tmp18_ = elements[0];
#line 150 "xkblayout.vala"
								if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 1274 "xkblayout.c"
									const gchar* _tmp19_;
									gchar* _tmp20_;
#line 151 "xkblayout.vala"
									_tmp19_ = retval;
#line 151 "xkblayout.vala"
									_tmp20_ = g_strdup (_tmp19_);
#line 151 "xkblayout.vala"
									_g_free0 (*layout);
#line 151 "xkblayout.vala"
									*layout = _tmp20_;
#line 1285 "xkblayout.c"
								} else {
									const gchar* _tmp21_;
									const gchar* _tmp22_;
#line 152 "xkblayout.vala"
									_tmp21_ = element;
#line 152 "xkblayout.vala"
									_tmp22_ = elements[1];
#line 152 "xkblayout.vala"
									if (g_strcmp0 (_tmp21_, _tmp22_) == 0) {
#line 1295 "xkblayout.c"
										const gchar* _tmp23_;
										gchar* _tmp24_;
#line 153 "xkblayout.vala"
										_tmp23_ = retval;
#line 153 "xkblayout.vala"
										_tmp24_ = g_strdup (_tmp23_);
#line 153 "xkblayout.vala"
										_g_free0 (*variant);
#line 153 "xkblayout.vala"
										*variant = _tmp24_;
#line 1306 "xkblayout.c"
									} else {
										const gchar* _tmp25_;
										const gchar* _tmp26_;
#line 154 "xkblayout.vala"
										_tmp25_ = element;
#line 154 "xkblayout.vala"
										_tmp26_ = elements[2];
#line 154 "xkblayout.vala"
										if (g_strcmp0 (_tmp25_, _tmp26_) == 0) {
#line 1316 "xkblayout.c"
											const gchar* _tmp27_;
											gchar* _tmp28_;
#line 155 "xkblayout.vala"
											_tmp27_ = retval;
#line 155 "xkblayout.vala"
											_tmp28_ = g_strdup (_tmp27_);
#line 155 "xkblayout.vala"
											_g_free0 (*option);
#line 155 "xkblayout.vala"
											*option = _tmp28_;
#line 1327 "xkblayout.c"
										}
									}
								}
							}
#line 144 "xkblayout.vala"
							_g_free0 (retval);
#line 1334 "xkblayout.c"
						}
					}
				}
#line 142 "xkblayout.vala"
				_g_free0 (line);
#line 1340 "xkblayout.c"
			}
		}
#line 142 "xkblayout.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1345 "xkblayout.c"
	}
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 181 "xkblayout.vala"
	for (i = 0; i < stack_length; i++) {
#line 181 "xkblayout.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 181 "xkblayout.vala"
			return TRUE;
#line 1361 "xkblayout.c"
		}
	}
#line 181 "xkblayout.vala"
	return FALSE;
#line 1366 "xkblayout.c"
}

static void
_vala_array_add33 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 220 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 220 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 220 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1381 "xkblayout.c"
	}
#line 220 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 220 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1387 "xkblayout.c"
}

static void
_vala_array_add34 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 221 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 221 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 221 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1402 "xkblayout.c"
	}
#line 221 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 221 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1408 "xkblayout.c"
}

static void
_vala_array_add35 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 222 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 222 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 222 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1423 "xkblayout.c"
	}
#line 222 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 222 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1429 "xkblayout.c"
}

static void
_vala_array_add36 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 224 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 224 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 224 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1444 "xkblayout.c"
	}
#line 224 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 224 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1450 "xkblayout.c"
}

static void
_vala_array_add37 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 225 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 225 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 225 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1465 "xkblayout.c"
	}
#line 225 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 225 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1471 "xkblayout.c"
}

static void
_vala_array_add38 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 229 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 229 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 229 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1486 "xkblayout.c"
	}
#line 229 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 229 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1492 "xkblayout.c"
}

static void
_vala_array_add39 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 230 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 230 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 230 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1507 "xkblayout.c"
	}
#line 230 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 230 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1513 "xkblayout.c"
}

static void
_vala_array_add40 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 231 "xkblayout.vala"
	if ((*length) == (*size)) {
#line 231 "xkblayout.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 231 "xkblayout.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1528 "xkblayout.c"
	}
#line 231 "xkblayout.vala"
	(*array)[(*length)++] = value;
#line 231 "xkblayout.vala"
	(*array)[*length] = NULL;
#line 1534 "xkblayout.c"
}

void
xkb_layout_set_layout (XKBLayout* self,
                       IBusEngineDesc* engine)
{
	gchar* layout = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* variant = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* option = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gboolean need_us_layout = FALSE;
	const gchar* _tmp16_;
	gboolean _tmp19_ = FALSE;
	const gchar* _tmp26_;
	gboolean _tmp30_ = FALSE;
	const gchar* _tmp31_;
	const gchar* _tmp37_;
	gboolean _tmp38_ = FALSE;
	const gchar* _tmp39_;
	gchar** args = NULL;
	gchar** _tmp59_;
	gint args_length1;
	gint _args_size_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	const gchar* _tmp62_;
	gchar* _tmp63_;
	gboolean _tmp64_ = FALSE;
	gboolean _tmp65_ = FALSE;
	const gchar* _tmp66_;
	gboolean _tmp72_ = FALSE;
	gboolean _tmp73_ = FALSE;
	const gchar* _tmp74_;
	gchar* standard_error = NULL;
	gint exit_status = 0;
	GError* _inner_error0_ = NULL;
#line 162 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 162 "xkblayout.vala"
	g_return_if_fail (engine != NULL);
#line 163 "xkblayout.vala"
	_tmp0_ = ibus_engine_desc_get_layout (engine);
#line 163 "xkblayout.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 163 "xkblayout.vala"
	layout = _tmp1_;
#line 164 "xkblayout.vala"
	_tmp2_ = ibus_engine_desc_get_layout_variant (engine);
#line 164 "xkblayout.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 164 "xkblayout.vala"
	variant = _tmp3_;
#line 165 "xkblayout.vala"
	_tmp4_ = ibus_engine_desc_get_layout_option (engine);
#line 165 "xkblayout.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 165 "xkblayout.vala"
	option = _tmp5_;
#line 167 "xkblayout.vala"
	_tmp6_ = layout;
#line 167 "xkblayout.vala"
	_vala_assert (_tmp6_ != NULL, "layout != null");
#line 173 "xkblayout.vala"
	_tmp9_ = layout;
#line 173 "xkblayout.vala"
	if (g_strcmp0 (_tmp9_, "default") == 0) {
#line 1610 "xkblayout.c"
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
#line 174 "xkblayout.vala"
		_tmp11_ = variant;
#line 174 "xkblayout.vala"
		if (g_strcmp0 (_tmp11_, "default") == 0) {
#line 174 "xkblayout.vala"
			_tmp10_ = TRUE;
#line 1619 "xkblayout.c"
		} else {
			const gchar* _tmp12_;
#line 174 "xkblayout.vala"
			_tmp12_ = variant;
#line 174 "xkblayout.vala"
			_tmp10_ = g_strcmp0 (_tmp12_, "") == 0;
#line 1626 "xkblayout.c"
		}
#line 174 "xkblayout.vala"
		_tmp8_ = _tmp10_;
#line 1630 "xkblayout.c"
	} else {
#line 173 "xkblayout.vala"
		_tmp8_ = FALSE;
#line 1634 "xkblayout.c"
	}
#line 173 "xkblayout.vala"
	if (_tmp8_) {
#line 1638 "xkblayout.c"
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
#line 175 "xkblayout.vala"
		_tmp14_ = option;
#line 175 "xkblayout.vala"
		if (g_strcmp0 (_tmp14_, "default") == 0) {
#line 175 "xkblayout.vala"
			_tmp13_ = TRUE;
#line 1647 "xkblayout.c"
		} else {
			const gchar* _tmp15_;
#line 175 "xkblayout.vala"
			_tmp15_ = option;
#line 175 "xkblayout.vala"
			_tmp13_ = g_strcmp0 (_tmp15_, "") == 0;
#line 1654 "xkblayout.c"
		}
#line 175 "xkblayout.vala"
		_tmp7_ = _tmp13_;
#line 1658 "xkblayout.c"
	} else {
#line 173 "xkblayout.vala"
		_tmp7_ = FALSE;
#line 1662 "xkblayout.c"
	}
#line 173 "xkblayout.vala"
	if (_tmp7_) {
#line 176 "xkblayout.vala"
		_g_free0 (option);
#line 176 "xkblayout.vala"
		_g_free0 (variant);
#line 176 "xkblayout.vala"
		_g_free0 (layout);
#line 176 "xkblayout.vala"
		return;
#line 1674 "xkblayout.c"
	}
#line 179 "xkblayout.vala"
	need_us_layout = FALSE;
#line 180 "xkblayout.vala"
	_tmp16_ = variant;
#line 180 "xkblayout.vala"
	if (g_strcmp0 (_tmp16_, "eng") != 0) {
#line 1682 "xkblayout.c"
		const gchar* _tmp17_;
		gchar** _tmp18_;
		gint _tmp18__length1;
#line 181 "xkblayout.vala"
		_tmp17_ = layout;
#line 181 "xkblayout.vala"
		_tmp18_ = self->priv->m_xkb_latin_layouts;
#line 181 "xkblayout.vala"
		_tmp18__length1 = self->priv->m_xkb_latin_layouts_length1;
#line 181 "xkblayout.vala"
		need_us_layout = _vala_string_array_contains (_tmp18_, _tmp18__length1, _tmp17_);
#line 1694 "xkblayout.c"
	}
#line 182 "xkblayout.vala"
	if (!need_us_layout) {
#line 1698 "xkblayout.c"
		const gchar* _tmp20_;
#line 182 "xkblayout.vala"
		_tmp20_ = variant;
#line 182 "xkblayout.vala"
		_tmp19_ = _tmp20_ != NULL;
#line 1704 "xkblayout.c"
	} else {
#line 182 "xkblayout.vala"
		_tmp19_ = FALSE;
#line 1708 "xkblayout.c"
	}
#line 182 "xkblayout.vala"
	if (_tmp19_) {
#line 1712 "xkblayout.c"
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar** _tmp25_;
		gint _tmp25__length1;
#line 183 "xkblayout.vala"
		_tmp21_ = layout;
#line 183 "xkblayout.vala"
		_tmp22_ = variant;
#line 183 "xkblayout.vala"
		_tmp23_ = g_strdup_printf ("%s(%s)", _tmp21_, _tmp22_);
#line 183 "xkblayout.vala"
		_tmp24_ = _tmp23_;
#line 183 "xkblayout.vala"
		_tmp25_ = self->priv->m_xkb_latin_layouts;
#line 183 "xkblayout.vala"
		_tmp25__length1 = self->priv->m_xkb_latin_layouts_length1;
#line 183 "xkblayout.vala"
		need_us_layout = _vala_string_array_contains (_tmp25_, _tmp25__length1, _tmp24_);
#line 183 "xkblayout.vala"
		_g_free0 (_tmp24_);
#line 1735 "xkblayout.c"
	}
#line 186 "xkblayout.vala"
	_tmp26_ = self->priv->m_default_layout;
#line 186 "xkblayout.vala"
	if (g_strcmp0 (_tmp26_, "") == 0) {
#line 1741 "xkblayout.c"
		gchar* _tmp27_ = NULL;
		gchar* _tmp28_ = NULL;
		gchar* _tmp29_ = NULL;
#line 187 "xkblayout.vala"
		xkb_layout_get_layout (self, &_tmp27_, &_tmp28_, &_tmp29_);
#line 187 "xkblayout.vala"
		_g_free0 (self->priv->m_default_layout);
#line 187 "xkblayout.vala"
		self->priv->m_default_layout = _tmp27_;
#line 187 "xkblayout.vala"
		_g_free0 (self->priv->m_default_variant);
#line 187 "xkblayout.vala"
		self->priv->m_default_variant = _tmp28_;
#line 187 "xkblayout.vala"
		_g_free0 (self->priv->m_default_option);
#line 187 "xkblayout.vala"
		self->priv->m_default_option = _tmp29_;
#line 1759 "xkblayout.c"
	}
#line 192 "xkblayout.vala"
	_tmp31_ = layout;
#line 192 "xkblayout.vala"
	if (g_strcmp0 (_tmp31_, "default") == 0) {
#line 192 "xkblayout.vala"
		_tmp30_ = TRUE;
#line 1767 "xkblayout.c"
	} else {
		const gchar* _tmp32_;
#line 192 "xkblayout.vala"
		_tmp32_ = layout;
#line 192 "xkblayout.vala"
		_tmp30_ = g_strcmp0 (_tmp32_, "") == 0;
#line 1774 "xkblayout.c"
	}
#line 192 "xkblayout.vala"
	if (_tmp30_) {
#line 1778 "xkblayout.c"
		const gchar* _tmp33_;
		gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
#line 193 "xkblayout.vala"
		_tmp33_ = self->priv->m_default_layout;
#line 193 "xkblayout.vala"
		_tmp34_ = g_strdup (_tmp33_);
#line 193 "xkblayout.vala"
		_g_free0 (layout);
#line 193 "xkblayout.vala"
		layout = _tmp34_;
#line 194 "xkblayout.vala"
		_tmp35_ = self->priv->m_default_variant;
#line 194 "xkblayout.vala"
		_tmp36_ = g_strdup (_tmp35_);
#line 194 "xkblayout.vala"
		_g_free0 (variant);
#line 194 "xkblayout.vala"
		variant = _tmp36_;
#line 1799 "xkblayout.c"
	}
#line 197 "xkblayout.vala"
	_tmp37_ = layout;
#line 197 "xkblayout.vala"
	if (g_strcmp0 (_tmp37_, "") == 0) {
#line 198 "xkblayout.vala"
		g_warning ("xkblayout.vala:198: Could not get the correct layout");
#line 199 "xkblayout.vala"
		_g_free0 (option);
#line 199 "xkblayout.vala"
		_g_free0 (variant);
#line 199 "xkblayout.vala"
		_g_free0 (layout);
#line 199 "xkblayout.vala"
		return;
#line 1815 "xkblayout.c"
	}
#line 202 "xkblayout.vala"
	_tmp39_ = option;
#line 202 "xkblayout.vala"
	if (g_strcmp0 (_tmp39_, "default") == 0) {
#line 202 "xkblayout.vala"
		_tmp38_ = TRUE;
#line 1823 "xkblayout.c"
	} else {
		const gchar* _tmp40_;
#line 202 "xkblayout.vala"
		_tmp40_ = option;
#line 202 "xkblayout.vala"
		_tmp38_ = g_strcmp0 (_tmp40_, "") == 0;
#line 1830 "xkblayout.c"
	}
#line 202 "xkblayout.vala"
	if (_tmp38_) {
#line 1834 "xkblayout.c"
		const gchar* _tmp41_;
		gchar* _tmp42_;
#line 203 "xkblayout.vala"
		_tmp41_ = self->priv->m_default_option;
#line 203 "xkblayout.vala"
		_tmp42_ = g_strdup (_tmp41_);
#line 203 "xkblayout.vala"
		_g_free0 (option);
#line 203 "xkblayout.vala"
		option = _tmp42_;
#line 1845 "xkblayout.c"
	} else {
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		gchar** _tmp45_;
		gchar** _tmp46_;
		gchar** _tmp47_;
		gint _tmp47__length1;
		gboolean _tmp48_;
#line 205 "xkblayout.vala"
		_tmp43_ = option;
#line 205 "xkblayout.vala"
		_tmp44_ = self->priv->m_default_option;
#line 205 "xkblayout.vala"
		_tmp46_ = _tmp45_ = g_strsplit (_tmp44_, ",", 0);
#line 205 "xkblayout.vala"
		_tmp47_ = _tmp46_;
#line 205 "xkblayout.vala"
		_tmp47__length1 = _vala_array_length (_tmp45_);
#line 205 "xkblayout.vala"
		_tmp48_ = !_vala_string_array_contains (_tmp47_, _vala_array_length (_tmp45_), _tmp43_);
#line 205 "xkblayout.vala"
		_tmp47_ = (_vala_array_free (_tmp47_, _tmp47__length1, (GDestroyNotify) g_free), NULL);
#line 205 "xkblayout.vala"
		if (_tmp48_) {
#line 1870 "xkblayout.c"
			const gchar* _tmp49_;
			const gchar* _tmp50_;
			gchar* _tmp51_;
#line 206 "xkblayout.vala"
			_tmp49_ = self->priv->m_default_option;
#line 206 "xkblayout.vala"
			_tmp50_ = option;
#line 206 "xkblayout.vala"
			_tmp51_ = g_strdup_printf ("%s,%s", _tmp49_, _tmp50_);
#line 206 "xkblayout.vala"
			_g_free0 (option);
#line 206 "xkblayout.vala"
			option = _tmp51_;
#line 1884 "xkblayout.c"
		} else {
			const gchar* _tmp52_;
			gchar* _tmp53_;
#line 208 "xkblayout.vala"
			_tmp52_ = self->priv->m_default_option;
#line 208 "xkblayout.vala"
			_tmp53_ = g_strdup (_tmp52_);
#line 208 "xkblayout.vala"
			_g_free0 (option);
#line 208 "xkblayout.vala"
			option = _tmp53_;
#line 1896 "xkblayout.c"
		}
	}
#line 212 "xkblayout.vala"
	if (need_us_layout) {
#line 1901 "xkblayout.c"
		const gchar* _tmp54_;
		gchar* _tmp55_;
		const gchar* _tmp56_;
#line 213 "xkblayout.vala"
		_tmp54_ = layout;
#line 213 "xkblayout.vala"
		_tmp55_ = g_strconcat (_tmp54_, ",us", NULL);
#line 213 "xkblayout.vala"
		_g_free0 (layout);
#line 213 "xkblayout.vala"
		layout = _tmp55_;
#line 214 "xkblayout.vala"
		_tmp56_ = variant;
#line 214 "xkblayout.vala"
		if (_tmp56_ != NULL) {
#line 1917 "xkblayout.c"
			const gchar* _tmp57_;
			gchar* _tmp58_;
#line 215 "xkblayout.vala"
			_tmp57_ = variant;
#line 215 "xkblayout.vala"
			_tmp58_ = g_strconcat (_tmp57_, ",", NULL);
#line 215 "xkblayout.vala"
			_g_free0 (variant);
#line 215 "xkblayout.vala"
			variant = _tmp58_;
#line 1928 "xkblayout.c"
		}
	}
#line 219 "xkblayout.vala"
	_tmp59_ = g_new0 (gchar*, 0 + 1);
#line 219 "xkblayout.vala"
	args = _tmp59_;
#line 219 "xkblayout.vala"
	args_length1 = 0;
#line 219 "xkblayout.vala"
	_args_size_ = args_length1;
#line 220 "xkblayout.vala"
	_tmp60_ = g_strdup (XKB_LAYOUT_XKB_COMMAND);
#line 220 "xkblayout.vala"
	_vala_array_add33 (&args, &args_length1, &_args_size_, _tmp60_);
#line 221 "xkblayout.vala"
	_tmp61_ = g_strdup (XKB_LAYOUT_XKB_LAYOUT_ARG);
#line 221 "xkblayout.vala"
	_vala_array_add34 (&args, &args_length1, &_args_size_, _tmp61_);
#line 222 "xkblayout.vala"
	_tmp62_ = layout;
#line 222 "xkblayout.vala"
	_tmp63_ = g_strdup (_tmp62_);
#line 222 "xkblayout.vala"
	_vala_array_add35 (&args, &args_length1, &_args_size_, _tmp63_);
#line 223 "xkblayout.vala"
	_tmp66_ = variant;
#line 223 "xkblayout.vala"
	if (_tmp66_ != NULL) {
#line 1957 "xkblayout.c"
		const gchar* _tmp67_;
#line 223 "xkblayout.vala"
		_tmp67_ = variant;
#line 223 "xkblayout.vala"
		_tmp65_ = g_strcmp0 (_tmp67_, "") != 0;
#line 1963 "xkblayout.c"
	} else {
#line 223 "xkblayout.vala"
		_tmp65_ = FALSE;
#line 1967 "xkblayout.c"
	}
#line 223 "xkblayout.vala"
	if (_tmp65_) {
#line 1971 "xkblayout.c"
		const gchar* _tmp68_;
#line 223 "xkblayout.vala"
		_tmp68_ = variant;
#line 223 "xkblayout.vala"
		_tmp64_ = g_strcmp0 (_tmp68_, "default") != 0;
#line 1977 "xkblayout.c"
	} else {
#line 223 "xkblayout.vala"
		_tmp64_ = FALSE;
#line 1981 "xkblayout.c"
	}
#line 223 "xkblayout.vala"
	if (_tmp64_) {
#line 1985 "xkblayout.c"
		gchar* _tmp69_;
		const gchar* _tmp70_;
		gchar* _tmp71_;
#line 224 "xkblayout.vala"
		_tmp69_ = g_strdup ("-variant");
#line 224 "xkblayout.vala"
		_vala_array_add36 (&args, &args_length1, &_args_size_, _tmp69_);
#line 225 "xkblayout.vala"
		_tmp70_ = variant;
#line 225 "xkblayout.vala"
		_tmp71_ = g_strdup (_tmp70_);
#line 225 "xkblayout.vala"
		_vala_array_add37 (&args, &args_length1, &_args_size_, _tmp71_);
#line 1999 "xkblayout.c"
	}
#line 227 "xkblayout.vala"
	_tmp74_ = option;
#line 227 "xkblayout.vala"
	if (_tmp74_ != NULL) {
#line 2005 "xkblayout.c"
		const gchar* _tmp75_;
#line 227 "xkblayout.vala"
		_tmp75_ = option;
#line 227 "xkblayout.vala"
		_tmp73_ = g_strcmp0 (_tmp75_, "") != 0;
#line 2011 "xkblayout.c"
	} else {
#line 227 "xkblayout.vala"
		_tmp73_ = FALSE;
#line 2015 "xkblayout.c"
	}
#line 227 "xkblayout.vala"
	if (_tmp73_) {
#line 2019 "xkblayout.c"
		const gchar* _tmp76_;
#line 227 "xkblayout.vala"
		_tmp76_ = option;
#line 227 "xkblayout.vala"
		_tmp72_ = g_strcmp0 (_tmp76_, "default") != 0;
#line 2025 "xkblayout.c"
	} else {
#line 227 "xkblayout.vala"
		_tmp72_ = FALSE;
#line 2029 "xkblayout.c"
	}
#line 227 "xkblayout.vala"
	if (_tmp72_) {
#line 2033 "xkblayout.c"
		gchar* _tmp77_;
		gchar* _tmp78_;
		const gchar* _tmp79_;
		gchar* _tmp80_;
#line 229 "xkblayout.vala"
		_tmp77_ = g_strdup ("-option");
#line 229 "xkblayout.vala"
		_vala_array_add38 (&args, &args_length1, &_args_size_, _tmp77_);
#line 230 "xkblayout.vala"
		_tmp78_ = g_strdup ("-option");
#line 230 "xkblayout.vala"
		_vala_array_add39 (&args, &args_length1, &_args_size_, _tmp78_);
#line 231 "xkblayout.vala"
		_tmp79_ = option;
#line 231 "xkblayout.vala"
		_tmp80_ = g_strdup (_tmp79_);
#line 231 "xkblayout.vala"
		_vala_array_add40 (&args, &args_length1, &_args_size_, _tmp80_);
#line 2052 "xkblayout.c"
	}
#line 234 "xkblayout.vala"
	standard_error = NULL;
#line 235 "xkblayout.vala"
	exit_status = 0;
#line 2058 "xkblayout.c"
	{
		gboolean _tmp81_ = FALSE;
		gchar** _tmp82_;
		gint _tmp82__length1;
		gchar* _tmp83_ = NULL;
		gint _tmp84_ = 0;
		gboolean _tmp85_;
#line 237 "xkblayout.vala"
		_tmp82_ = args;
#line 237 "xkblayout.vala"
		_tmp82__length1 = args_length1;
#line 237 "xkblayout.vala"
		_tmp85_ = g_spawn_sync (NULL, _tmp82_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, &_tmp83_, &_tmp84_, &_inner_error0_);
#line 237 "xkblayout.vala"
		_g_free0 (standard_error);
#line 237 "xkblayout.vala"
		standard_error = _tmp83_;
#line 237 "xkblayout.vala"
		exit_status = _tmp84_;
#line 237 "xkblayout.vala"
		_tmp81_ = _tmp85_;
#line 237 "xkblayout.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 237 "xkblayout.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 2084 "xkblayout.c"
				goto __catch0_g_spawn_error;
			}
#line 237 "xkblayout.vala"
			_g_free0 (standard_error);
#line 237 "xkblayout.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 237 "xkblayout.vala"
			_g_free0 (option);
#line 237 "xkblayout.vala"
			_g_free0 (variant);
#line 237 "xkblayout.vala"
			_g_free0 (layout);
#line 237 "xkblayout.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 237 "xkblayout.vala"
			g_clear_error (&_inner_error0_);
#line 237 "xkblayout.vala"
			return;
#line 2103 "xkblayout.c"
		}
#line 237 "xkblayout.vala"
		if (!_tmp81_) {
#line 2107 "xkblayout.c"
			const gchar* _tmp86_;
#line 245 "xkblayout.vala"
			_tmp86_ = ibus_engine_desc_get_layout (engine);
#line 245 "xkblayout.vala"
			g_warning ("xkblayout.vala:245: Switch xkb layout to %s failed.", _tmp86_);
#line 2113 "xkblayout.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp87_;
		const gchar* _tmp88_;
#line 236 "xkblayout.vala"
		e = _inner_error0_;
#line 236 "xkblayout.vala"
		_inner_error0_ = NULL;
#line 248 "xkblayout.vala"
		_tmp87_ = e;
#line 248 "xkblayout.vala"
		_tmp88_ = _tmp87_->message;
#line 248 "xkblayout.vala"
		g_warning ("xkblayout.vala:248: Execute setxkbmap failed: %s", _tmp88_);
#line 249 "xkblayout.vala"
		_g_error_free0 (e);
#line 249 "xkblayout.vala"
		_g_free0 (standard_error);
#line 249 "xkblayout.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 249 "xkblayout.vala"
		_g_free0 (option);
#line 249 "xkblayout.vala"
		_g_free0 (variant);
#line 249 "xkblayout.vala"
		_g_free0 (layout);
#line 249 "xkblayout.vala"
		return;
#line 2146 "xkblayout.c"
	}
	__finally0:
#line 236 "xkblayout.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 236 "xkblayout.vala"
		_g_free0 (standard_error);
#line 236 "xkblayout.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 236 "xkblayout.vala"
		_g_free0 (option);
#line 236 "xkblayout.vala"
		_g_free0 (variant);
#line 236 "xkblayout.vala"
		_g_free0 (layout);
#line 236 "xkblayout.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 236 "xkblayout.vala"
		g_clear_error (&_inner_error0_);
#line 236 "xkblayout.vala"
		return;
#line 2167 "xkblayout.c"
	}
#line 252 "xkblayout.vala"
	if (exit_status != 0) {
#line 2171 "xkblayout.c"
		const gchar* _tmp89_ = NULL;
		const gchar* _tmp90_;
#line 254 "xkblayout.vala"
		_tmp90_ = standard_error;
#line 254 "xkblayout.vala"
		_tmp89_ = _tmp90_;
#line 254 "xkblayout.vala"
		if (_tmp89_ == NULL) {
#line 254 "xkblayout.vala"
			_tmp89_ = "(null)";
#line 2182 "xkblayout.c"
		}
#line 253 "xkblayout.vala"
		g_warning ("xkblayout.vala:253: Execute setxkbmap failed: %s", _tmp89_);
#line 2186 "xkblayout.c"
	}
#line 256 "xkblayout.vala"
	xkb_layout_run_xmodmap (self);
#line 162 "xkblayout.vala"
	_g_free0 (standard_error);
#line 162 "xkblayout.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 162 "xkblayout.vala"
	_g_free0 (option);
#line 162 "xkblayout.vala"
	_g_free0 (variant);
#line 162 "xkblayout.vala"
	_g_free0 (layout);
#line 2200 "xkblayout.c"
}

void
xkb_layout_run_xmodmap (XKBLayout* self)
{
	gchar* homedir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 260 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 261 "xkblayout.vala"
	if (!self->priv->m_use_xmodmap) {
#line 262 "xkblayout.vala"
		return;
#line 2216 "xkblayout.c"
	}
#line 265 "xkblayout.vala"
	_tmp0_ = g_get_home_dir ();
#line 265 "xkblayout.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 265 "xkblayout.vala"
	homedir = _tmp1_;
#line 2224 "xkblayout.c"
	{
		const gchar** xmodmap_file_collection = NULL;
		gint xmodmap_file_collection_length1 = 0;
		gint _xmodmap_file_collection_size_ = 0;
		gint xmodmap_file_it = 0;
#line 266 "xkblayout.vala"
		xmodmap_file_collection = XKB_LAYOUT_XMODMAP_KNOWN_FILES;
#line 266 "xkblayout.vala"
		xmodmap_file_collection_length1 = G_N_ELEMENTS (XKB_LAYOUT_XMODMAP_KNOWN_FILES);
#line 266 "xkblayout.vala"
		for (xmodmap_file_it = 0; xmodmap_file_it < xmodmap_file_collection_length1; xmodmap_file_it = xmodmap_file_it + 1) {
#line 2236 "xkblayout.c"
			gchar* _tmp2_;
			gchar* xmodmap_file = NULL;
#line 266 "xkblayout.vala"
			_tmp2_ = g_strdup (xmodmap_file_collection[xmodmap_file_it]);
#line 266 "xkblayout.vala"
			xmodmap_file = _tmp2_;
#line 2243 "xkblayout.c"
			{
				gchar* xmodmap_filepath = NULL;
				const gchar* _tmp3_;
				const gchar* _tmp4_;
				gchar* _tmp5_;
				const gchar* _tmp6_;
				gchar** args = NULL;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar** _tmp10_;
				gint args_length1;
				gint _args_size_;
#line 267 "xkblayout.vala"
				_tmp3_ = homedir;
#line 267 "xkblayout.vala"
				_tmp4_ = xmodmap_file;
#line 267 "xkblayout.vala"
				_tmp5_ = g_build_filename (_tmp3_, _tmp4_, NULL);
#line 267 "xkblayout.vala"
				xmodmap_filepath = _tmp5_;
#line 270 "xkblayout.vala"
				_tmp6_ = xmodmap_filepath;
#line 270 "xkblayout.vala"
				if (!g_file_test (_tmp6_, G_FILE_TEST_EXISTS)) {
#line 271 "xkblayout.vala"
					_g_free0 (xmodmap_filepath);
#line 271 "xkblayout.vala"
					_g_free0 (xmodmap_file);
#line 271 "xkblayout.vala"
					continue;
#line 2275 "xkblayout.c"
				}
#line 274 "xkblayout.vala"
				_tmp7_ = g_strdup (XKB_LAYOUT_XMODMAP_COMMAND);
#line 274 "xkblayout.vala"
				_tmp8_ = xmodmap_filepath;
#line 274 "xkblayout.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 274 "xkblayout.vala"
				_tmp10_ = g_new0 (gchar*, 2 + 1);
#line 274 "xkblayout.vala"
				_tmp10_[0] = _tmp7_;
#line 274 "xkblayout.vala"
				_tmp10_[1] = _tmp9_;
#line 274 "xkblayout.vala"
				args = _tmp10_;
#line 274 "xkblayout.vala"
				args_length1 = 2;
#line 274 "xkblayout.vala"
				_args_size_ = args_length1;
#line 2295 "xkblayout.c"
				{
					gchar** _tmp11_;
					gint _tmp11__length1;
#line 285 "xkblayout.vala"
					_tmp11_ = args;
#line 285 "xkblayout.vala"
					_tmp11__length1 = args_length1;
#line 285 "xkblayout.vala"
					g_spawn_async (NULL, _tmp11_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, &_inner_error0_);
#line 285 "xkblayout.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 285 "xkblayout.vala"
						if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 2309 "xkblayout.c"
							goto __catch0_g_spawn_error;
						}
#line 285 "xkblayout.vala"
						args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 285 "xkblayout.vala"
						_g_free0 (xmodmap_filepath);
#line 285 "xkblayout.vala"
						_g_free0 (xmodmap_file);
#line 285 "xkblayout.vala"
						_g_free0 (homedir);
#line 285 "xkblayout.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 285 "xkblayout.vala"
						g_clear_error (&_inner_error0_);
#line 285 "xkblayout.vala"
						return;
#line 2326 "xkblayout.c"
					}
				}
				goto __finally0;
				__catch0_g_spawn_error:
				{
					GError* e = NULL;
					GError* _tmp12_;
					const gchar* _tmp13_;
#line 284 "xkblayout.vala"
					e = _inner_error0_;
#line 284 "xkblayout.vala"
					_inner_error0_ = NULL;
#line 292 "xkblayout.vala"
					_tmp12_ = e;
#line 292 "xkblayout.vala"
					_tmp13_ = _tmp12_->message;
#line 292 "xkblayout.vala"
					g_warning ("xkblayout.vala:292: Execute xmodmap is failed: %s\n", _tmp13_);
#line 293 "xkblayout.vala"
					_g_error_free0 (e);
#line 293 "xkblayout.vala"
					args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 293 "xkblayout.vala"
					_g_free0 (xmodmap_filepath);
#line 293 "xkblayout.vala"
					_g_free0 (xmodmap_file);
#line 293 "xkblayout.vala"
					_g_free0 (homedir);
#line 293 "xkblayout.vala"
					return;
#line 2357 "xkblayout.c"
				}
				__finally0:
#line 284 "xkblayout.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 284 "xkblayout.vala"
					args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 284 "xkblayout.vala"
					_g_free0 (xmodmap_filepath);
#line 284 "xkblayout.vala"
					_g_free0 (xmodmap_file);
#line 284 "xkblayout.vala"
					_g_free0 (homedir);
#line 284 "xkblayout.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 284 "xkblayout.vala"
					g_clear_error (&_inner_error0_);
#line 284 "xkblayout.vala"
					return;
#line 2376 "xkblayout.c"
				}
#line 296 "xkblayout.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 296 "xkblayout.vala"
				_g_free0 (xmodmap_filepath);
#line 296 "xkblayout.vala"
				_g_free0 (xmodmap_file);
#line 296 "xkblayout.vala"
				break;
#line 2386 "xkblayout.c"
			}
		}
	}
#line 260 "xkblayout.vala"
	_g_free0 (homedir);
#line 2392 "xkblayout.c"
}

void
xkb_layout_set_use_xmodmap (XKBLayout* self,
                            gboolean use_xmodmap)
{
#line 301 "xkblayout.vala"
	g_return_if_fail (self != NULL);
#line 302 "xkblayout.vala"
	self->priv->m_use_xmodmap = use_xmodmap;
#line 2403 "xkblayout.c"
}

static void
value_xkb_layout_init (GValue* value)
{
#line 25 "xkblayout.vala"
	value->data[0].v_pointer = NULL;
#line 2411 "xkblayout.c"
}

static void
value_xkb_layout_free_value (GValue* value)
{
#line 25 "xkblayout.vala"
	if (value->data[0].v_pointer) {
#line 25 "xkblayout.vala"
		xkb_layout_unref (value->data[0].v_pointer);
#line 2421 "xkblayout.c"
	}
}

static void
value_xkb_layout_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 25 "xkblayout.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "xkblayout.vala"
		dest_value->data[0].v_pointer = xkb_layout_ref (src_value->data[0].v_pointer);
#line 2433 "xkblayout.c"
	} else {
#line 25 "xkblayout.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2437 "xkblayout.c"
	}
}

static gpointer
value_xkb_layout_peek_pointer (const GValue* value)
{
#line 25 "xkblayout.vala"
	return value->data[0].v_pointer;
#line 2446 "xkblayout.c"
}

static gchar*
value_xkb_layout_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 25 "xkblayout.vala"
	if (collect_values[0].v_pointer) {
#line 2457 "xkblayout.c"
		XKBLayout * object;
		object = collect_values[0].v_pointer;
#line 25 "xkblayout.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "xkblayout.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2464 "xkblayout.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "xkblayout.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2468 "xkblayout.c"
		}
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = xkb_layout_ref (object);
#line 2472 "xkblayout.c"
	} else {
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = NULL;
#line 2476 "xkblayout.c"
	}
#line 25 "xkblayout.vala"
	return NULL;
#line 2480 "xkblayout.c"
}

static gchar*
value_xkb_layout_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	XKBLayout ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "xkblayout.vala"
	if (!object_p) {
#line 25 "xkblayout.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2495 "xkblayout.c"
	}
#line 25 "xkblayout.vala"
	if (!value->data[0].v_pointer) {
#line 25 "xkblayout.vala"
		*object_p = NULL;
#line 2501 "xkblayout.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "xkblayout.vala"
		*object_p = value->data[0].v_pointer;
#line 2505 "xkblayout.c"
	} else {
#line 25 "xkblayout.vala"
		*object_p = xkb_layout_ref (value->data[0].v_pointer);
#line 2509 "xkblayout.c"
	}
#line 25 "xkblayout.vala"
	return NULL;
#line 2513 "xkblayout.c"
}

GParamSpec*
param_spec_xkb_layout (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecXKBLayout* spec;
#line 25 "xkblayout.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_XKB_LAYOUT), NULL);
#line 25 "xkblayout.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "xkblayout.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "xkblayout.vala"
	return G_PARAM_SPEC (spec);
#line 2532 "xkblayout.c"
}

gpointer
value_get_xkb_layout (const GValue* value)
{
#line 25 "xkblayout.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_XKB_LAYOUT), NULL);
#line 25 "xkblayout.vala"
	return value->data[0].v_pointer;
#line 2542 "xkblayout.c"
}

void
value_set_xkb_layout (GValue* value,
                      gpointer v_object)
{
	XKBLayout * old;
#line 25 "xkblayout.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_XKB_LAYOUT));
#line 25 "xkblayout.vala"
	old = value->data[0].v_pointer;
#line 25 "xkblayout.vala"
	if (v_object) {
#line 25 "xkblayout.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_XKB_LAYOUT));
#line 25 "xkblayout.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = v_object;
#line 25 "xkblayout.vala"
		xkb_layout_ref (value->data[0].v_pointer);
#line 2564 "xkblayout.c"
	} else {
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = NULL;
#line 2568 "xkblayout.c"
	}
#line 25 "xkblayout.vala"
	if (old) {
#line 25 "xkblayout.vala"
		xkb_layout_unref (old);
#line 2574 "xkblayout.c"
	}
}

void
value_take_xkb_layout (GValue* value,
                       gpointer v_object)
{
	XKBLayout * old;
#line 25 "xkblayout.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_XKB_LAYOUT));
#line 25 "xkblayout.vala"
	old = value->data[0].v_pointer;
#line 25 "xkblayout.vala"
	if (v_object) {
#line 25 "xkblayout.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_XKB_LAYOUT));
#line 25 "xkblayout.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = v_object;
#line 2595 "xkblayout.c"
	} else {
#line 25 "xkblayout.vala"
		value->data[0].v_pointer = NULL;
#line 2599 "xkblayout.c"
	}
#line 25 "xkblayout.vala"
	if (old) {
#line 25 "xkblayout.vala"
		xkb_layout_unref (old);
#line 2605 "xkblayout.c"
	}
}

static void
xkb_layout_class_init (XKBLayoutClass * klass,
                       gpointer klass_data)
{
#line 25 "xkblayout.vala"
	xkb_layout_parent_class = g_type_class_peek_parent (klass);
#line 25 "xkblayout.vala"
	((XKBLayoutClass *) klass)->finalize = xkb_layout_finalize;
#line 25 "xkblayout.vala"
	g_type_class_adjust_private_offset (klass, &XKBLayout_private_offset);
#line 2619 "xkblayout.c"
}

static void
xkb_layout_instance_init (XKBLayout * self,
                          gpointer klass)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 25 "xkblayout.vala"
	self->priv = xkb_layout_get_instance_private (self);
#line 32 "xkblayout.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 32 "xkblayout.vala"
	self->priv->m_get_layout_args = _tmp0_;
#line 32 "xkblayout.vala"
	self->priv->m_get_layout_args_length1 = 0;
#line 32 "xkblayout.vala"
	self->priv->_m_get_layout_args_size_ = self->priv->m_get_layout_args_length1;
#line 33 "xkblayout.vala"
	_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 33 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts = _tmp1_;
#line 33 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts_length1 = 0;
#line 33 "xkblayout.vala"
	self->priv->_m_xkb_latin_layouts_size_ = self->priv->m_xkb_latin_layouts_length1;
#line 34 "xkblayout.vala"
	_tmp2_ = g_strdup ("");
#line 34 "xkblayout.vala"
	self->priv->m_default_layout = _tmp2_;
#line 35 "xkblayout.vala"
	_tmp3_ = g_strdup ("");
#line 35 "xkblayout.vala"
	self->priv->m_default_variant = _tmp3_;
#line 36 "xkblayout.vala"
	_tmp4_ = g_strdup ("");
#line 36 "xkblayout.vala"
	self->priv->m_default_option = _tmp4_;
#line 37 "xkblayout.vala"
	self->priv->m_use_xmodmap = TRUE;
#line 25 "xkblayout.vala"
	self->ref_count = 1;
#line 2665 "xkblayout.c"
}

static void
xkb_layout_finalize (XKBLayout * obj)
{
	XKBLayout * self;
#line 25 "xkblayout.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_XKB_LAYOUT, XKBLayout);
#line 25 "xkblayout.vala"
	g_signal_handlers_destroy (self);
#line 32 "xkblayout.vala"
	self->priv->m_get_layout_args = (_vala_array_free (self->priv->m_get_layout_args, self->priv->m_get_layout_args_length1, (GDestroyNotify) g_free), NULL);
#line 33 "xkblayout.vala"
	self->priv->m_xkb_latin_layouts = (_vala_array_free (self->priv->m_xkb_latin_layouts, self->priv->m_xkb_latin_layouts_length1, (GDestroyNotify) g_free), NULL);
#line 34 "xkblayout.vala"
	_g_free0 (self->priv->m_default_layout);
#line 35 "xkblayout.vala"
	_g_free0 (self->priv->m_default_variant);
#line 36 "xkblayout.vala"
	_g_free0 (self->priv->m_default_option);
#line 2686 "xkblayout.c"
}

static GType
xkb_layout_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_xkb_layout_init, value_xkb_layout_free_value, value_xkb_layout_copy_value, value_xkb_layout_peek_pointer, "p", value_xkb_layout_collect_value, "p", value_xkb_layout_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (XKBLayoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xkb_layout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XKBLayout), 0, (GInstanceInitFunc) xkb_layout_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType xkb_layout_type_id;
	xkb_layout_type_id = g_type_register_fundamental (g_type_fundamental_next (), "XKBLayout", &g_define_type_info, &g_define_type_fundamental_info, 0);
	XKBLayout_private_offset = g_type_add_instance_private (xkb_layout_type_id, sizeof (XKBLayoutPrivate));
	return xkb_layout_type_id;
}

GType
xkb_layout_get_type (void)
{
	static volatile gsize xkb_layout_type_id__once = 0;
	if (g_once_init_enter (&xkb_layout_type_id__once)) {
		GType xkb_layout_type_id;
		xkb_layout_type_id = xkb_layout_get_type_once ();
		g_once_init_leave (&xkb_layout_type_id__once, xkb_layout_type_id);
	}
	return xkb_layout_type_id__once;
}

gpointer
xkb_layout_ref (gpointer instance)
{
	XKBLayout * self;
	self = instance;
#line 25 "xkblayout.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "xkblayout.vala"
	return instance;
#line 2722 "xkblayout.c"
}

void
xkb_layout_unref (gpointer instance)
{
	XKBLayout * self;
	self = instance;
#line 25 "xkblayout.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "xkblayout.vala"
		XKB_LAYOUT_GET_CLASS (self)->finalize (self);
#line 25 "xkblayout.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2736 "xkblayout.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2747 "xkblayout.c"
		gssize i;
#line 23 "emojier.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 23 "emojier.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 23 "emojier.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2755 "xkblayout.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 23 "emojier.vala"
	g_free (array);
#line 2770 "xkblayout.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 23 "emojier.vala"
	if (array) {
#line 23 "emojier.vala"
		while (((gpointer*) array)[length]) {
#line 23 "emojier.vala"
			length++;
#line 2784 "xkblayout.c"
		}
	}
#line 23 "emojier.vala"
	return length;
#line 2789 "xkblayout.c"
}

